/* 
 Codelet from MILEPOST project: http://cTuning.org/project-milepost
 Updated by Grigori Fursin to work with Collective Mind Framework

 3 "./quantize-pvt.codelet__6.wrapper.c" 3 4
*/

#include <stdio.h>

int __astex_write_message(const char * format, ...);
int __astex_write_output(const char * format, ...);
void __astex_exit_on_error(const char * msg, int code, const char * additional_msg);
void * __astex_fopen(const char * name, const char * mode);
void * __astex_memalloc(long bytes);
void __astex_close_file(void * file);
void __astex_read_from_file(void * dest, long bytes, void * file);
int __astex_getenv_int(const char * var);
void * __astex_start_measure();
double __astex_stop_measure(void * _before);
typedef double  FLOAT8;
typedef FLOAT8  D576[576];
typedef FLOAT8  D192_3[192][3];
void  astex_codelet__6(FLOAT8 xr[576], int ix[576], const FLOAT8 compareval0, const FLOAT8 istep);
int main(int argc, const char **argv)
{
  FLOAT8  *xr;
  int  *ix;
  const FLOAT8  compareval0 = 0.012048 ;
  const FLOAT8  istep = 49.350746 ;
  void * codelet_data_file_descriptor = (void *) 0;

#ifdef OPENME
  openme_init(NULL,NULL,NULL,0);
  openme_callback("PROGRAM_START", NULL);
#endif

  if (argc < 2)
    __astex_exit_on_error("Please specify data file in command-line.", 1, argv[0]);
  codelet_data_file_descriptor = __astex_fopen(argv[1], "rb");
  
  char * xr__region_buffer = (char *) __astex_memalloc(4608);
  __astex_write_message("Reading xr value from %s\n", argv[1]);
  __astex_read_from_file(xr__region_buffer, 4608, codelet_data_file_descriptor);
  xr = (FLOAT8 *) (xr__region_buffer + 0l);
  char * ix__region_buffer = (char *) __astex_memalloc(2304);
  __astex_write_message("Reading ix value from %s\n", argv[1]);
  __astex_read_from_file(ix__region_buffer, 2304, codelet_data_file_descriptor);
  ix = (int *) (ix__region_buffer + 0l);
  void * _astex_timeval_before = __astex_start_measure();
  int _astex_wrap_loop = __astex_getenv_int("CT_REPEAT_MAIN");
  if (! _astex_wrap_loop)
    _astex_wrap_loop = 1;

#ifdef OPENME
  openme_callback("KERNEL_START", NULL);
#endif

  while (_astex_wrap_loop > 0)
  {
    --_astex_wrap_loop;
  astex_codelet__6(xr, ix, compareval0, istep);

  }

#ifdef OPENME
  openme_callback("KERNEL_END", NULL);
#endif

  __astex_write_output("Total time: %lf\n", __astex_stop_measure(_astex_timeval_before));


#ifdef OPENME
  openme_callback("PROGRAM_END", NULL);
#endif

  return 0;
}

